TurboJPEG 1.2.1

- Main Page
- Modules
- Data Structures

- Data Structures
- Data Structure Index
- Data Fields

All Data Structures Functions Variables Typedefs Enumerations Enumerator Groups
Data Fields
tjtransform Struct Reference
TurboJPEG

Lossless transform. More...

`#include <turbojpeg.h>`

## Data Fields
tjregion | r
| Cropping region. More...
int | op
| One of the transform operations. More...
int | options
| The bitwise OR of one of more of the transform options. More...
void * | data
| Arbitrary data that can be accessed within the body of the callback function. More...
int(* | customFilter )(short *coeffs, tjregion arrayRegion, tjregion planeRegion, int componentIndex, int transformIndex, struct tjtransform *transform)
| A callback function that can be used to modify the DCT coefficients after they are losslessly transformed but before they are transcoded to a new JPEG image. More...

## Detailed Description

Lossless transform.

## Field Documentation

int(* tjtransform::customFilter)(short *coeffs, tjregion arrayRegion, tjregion planeRegion, int componentIndex, int transformIndex, struct tjtransform *transform)

A callback function that can be used to modify the DCT coefficients after they are losslessly transformed but before they are transcoded to a new JPEG image.

This allows for custom filters or other transformations to be applied in the frequency domain.

Parameters

  coeffs | pointer to an array of transformed DCT coefficients. (NOTE: this pointer is not guaranteed to be valid once the callback returns, so applications wishing to hand off the DCT coefficients to another function or library should make a copy of them within the body of the callback.)
  arrayRegion | tjregion structure containing the width and height of the array pointed to by `coeffs` as well as its offset relative to the component plane. TurboJPEG implementations may choose to split each component plane into multiple DCT coefficient arrays and call the callback function once for each array.
  planeRegion | tjregion structure containing the width and height of the component plane to which `coeffs` belongs
  componentID | ID number of the component plane to which `coeffs` belongs (Y, Cb, and Cr have, respectively, ID's of 0, 1, and 2 in typical JPEG images.)
  transformID | ID number of the transformed image to which `coeffs` belongs. This is the same as the index of the transform in the `transforms` array that was passed to tjTransform().
  transform | a pointer to a tjtransform structure that specifies the parameters and/or cropping region for this transform

Returns
  0 if the callback was successful, or -1 if an error occurred.

void* tjtransform::data

Arbitrary data that can be accessed within the body of the callback function.

int tjtransform::op

One of the transform operations.

int tjtransform::options

The bitwise OR of one of more of the transform options.

tjregion tjtransform::r

Cropping region.

The documentation for this struct was generated from the following file:

- turbojpeg.h